
<template>
  <v-layout row wrap>
    <v-flex xs12>
      <h4>Médias PDFs</h4>
      <table class="v-datatable v-table theme--light tableauImages">
        <tbody>
          <tr v-for="(pdf, index) in tablePdfs" :key="pdf.id">
            <td>{{ listeLibellePdfs[index] }}</td>
            <td class="text-xs-left">
              <form>
                <input
                  :id="'media' + index"
                  :name="'media' + index"
                  type="file"
                  style="display:none"
                  :ref="'fileInput'"
                  @change="setImage"
                />

                <v-btn
                  color="info"
                  small
                  @click="selectionPdf(index)"
                  v-if="previewTn[index] == '' || previewTn[index] == null"
                >Choisir un pdf</v-btn>
                <v-btn
                  v-if="previewTn[index] != '' && previewTn[index] != null"
                  color="error"
                  small
                  @click="deletePdf(index)"
                >
                  <i class="material-icons">delete_forever</i> SUPPRIMER
                </v-btn>
              </form>
            </td>
            <td>
              <input
                type="text"
                :ref="'fileValue'"
                v-model="previewTn[index]"
                readonly
                v-if="previewTn[index] != '' && previewTn[index] != null"
              />
              <v-btn
                color="primary"
                v-if="previewTn[index] == '' || previewTn[index] == null"
                @click.stop="onUploadSelectedFileClick(index)"
              >UPLOAD</v-btn>
            </td>
          </tr>
        </tbody>
      </table>
    </v-flex>
    <v-flex xs12></v-flex>
    <loading
      :active.sync="isLoading"
      :can-cancel="true"
      :on-cancel="onCancel"
      :is-full-page="fullPage"
    ></loading>
  </v-layout>
</template>

<script>
import Vue from "vue";
// import axios from "axios";
import Loading from "vue-loading-overlay";
import "vue-loading-overlay/dist/vue-loading.css";
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_UPLOAD_CONFIG = URL_API + "api/upload-file";
const URL_API_DELETEIMAGES_FTP = URL_API + "api/images/delete-on-ftp";
export default {
  props: ["Popup", "action", "listeLibellePdfs", "tablePdfs", "tabPrevPdfTn", "tabPdfName", "recupRawData"],
  components: {
    loading: Loading,
  },
  mounted: function () {
    this.previewTn = this.tabPrevPdfTn;
    this.arrayPdfName = this.tabPdfName;
    this.setInfoPdfUpdate();
    if (this.action == "edit") {
      this.fetchPdfs();
    }
  },
  data() {
    return {
      arrayPdfName: [],
      isLoading: false,
      fullPage: true,
      previewTn: [],
      selectedIndex: null,
    };
  },

  methods: {
    onCancel() {
      console.log("User cancelled the loader.");
    },
    fetchPdfs() {
      let dataEdit = JSON.parse(this.recupRawData.data);
      // boucle sur tableimage
      if (this.tablePdfs) {
        this.tablePdfs.forEach((element, index) => {
          if (dataEdit["pdf" + (index + 1)] != undefined && dataEdit["pdf" + (index + 1)] != "" && dataEdit["pdf" + (index + 1)].length > 0) {
            let imgName = dataEdit["pdf" + (index + 1)];
            if (imgName != "" && imgName.length > 0) {
              // let url = FOLDER_URL + "tn/" + imgName;
              this.setPreviewTn(index, imgName);
              Vue.set(this.arrayPdfName, index, imgName);
            }
          }
        });
      }

      // affecter a preview img tn
    },

    setImage(e) {
      this.selectedFile = e.target.files[0];
      this.imageName = this.setImageName(this.selectedFile.name);
      this.uploadPercentage = 0;
      if (!this.selectedFile.type.includes("application/pdf")) {
        alert("Please select a pdf file");
        return;
      }
    },
    setImageName(rawName) {
      let newName = rawName;
      let tab1 = "ÀÁÂÃÄÅàáâãäåÒÓÔÕÖØòóôõöøÈÉÊËèéêëÇçÌÍÎÏìíîïÙÚÛÜùúûüÿÑñ";
      let tab2 = "aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn";
      let rep2 = tab1.split("");
      let rep = tab2.split("");
      let myarray = new Array();
      let i = -1;
      while (rep2[++i]) {
        myarray[rep2[i]] = rep[i];
      }
      myarray["Œ"] = "OE";
      myarray["œ"] = "oe";

      newName = newName.replace(/./g, function ($0) {
        return myarray[$0] ? myarray[$0] : $0;
      });
      newName = newName.replace(/[^.a-zA-Z0-9_-]/g, "");
      var random = Math.floor(Math.random() * 10000 + 1000);
      var unix = Math.round(+new Date() / 1000);
      return unix + random + newName;
    },

    setInfoPdfUpdate() {
      this.tablePdfs.forEach((element, index) => {
        //ATTENTION CETTE COMMANDE AGRANDIT INUTILEMENT LE TABLEAU EN MODE CREATE
        // Vue.set(this.previewTn, index, []);
        if (this.previewTn.length < this.tablePdfs.length) {
          this.previewTn.push([]);
          this.arrayPdfName.push([]);
        }
      });

      if (this.editMode) {
        //this.idImg = this.Popup.data.image1ID;
        //this.previewImg = this.Popup.data.image1Url;
      }
    },
    selectionPdf(index) {
      this.selectedIndex = index;
      this.$refs.fileInput[index].click();
    },
    onUploadSelectedFileClick(index) {
      let fileInputRef = "fileInput";
      let fileValueRef = "fileValue";
      if (this.$refs[fileInputRef][index].files[0]) {
        this.isLoading = true;
        let fileToUpload = this.$refs[fileInputRef][index].files[0];

        if (fileToUpload == undefined || fileToUpload == "") {
          this.snackbar.text = "Veuillez uploader un média valide";
          this.snackbar.actif = true;
          this.dialogLoader = false;
          return false;
        }

        self = this;
        this.dialogLoader = true;

        let formData = new FormData();
        formData.append("file", fileToUpload);
        formData.append("folder", "pdf");
        formData.append("aliasFolder", process.env.VUE_APP_SITE_ALIAS);

        this.$axios
          .post(URL_UPLOAD_CONFIG, formData, {
            headers: {
              "Content-Type": "multipart/form-data",
            },
          })
          .then((response) => {
            // fileValueRef = response.data.imgName;
            self.setPreviewTn(self.selectedIndex, response.data.imgName);
            Vue.set(self.arrayPdfName, self.selectedIndex, response.data.imgName);
            //passage info  au parent
            self.$emit("childToParent", self.arrayPdfName);
            self.isLoading = false;
          })
          .catch((error) => {
            console.log("error", error);
          })
          .then(function () {
            self.dialogLoader = false;
          });
      }
    },
    setPreviewTn(idx, name) {
      Vue.set(this.previewTn, idx, name);
    },
    deletePdf(idx) {
      this.arrayPdfName[idx] = null; // todo a passer en []
      this.setPreviewTn(idx, null);
      this.$emit("childToParent", this.arrayPdfName);

      // suppression ftp désactivé temporairement
      // sera déplacé dans le futur dans une fonction nettoyage
      // this.isLoading = true;
      // let urlDelete = "";
      // let payload = {
      //   name: this.arrayPdfName[idx],
      //   isPdf: true
      // };
      // axios
      //   .post(URL_API_DELETEIMAGES_FTP, payload)
      //   .then(response => {
      //     this.arrayPdfName[idx] = null; // todo a passer en []
      //     this.setPreviewTn(idx, null);
      //     //passage info au parent
      //     this.$emit("childToParent", this.arrayPdfName);
      //     this.isLoading = false;
      //   })
      //   .catch(error => {
      //     console.log("error = ", error);
      //     this.isLoading = false;
      //   });
    },
  },
};
</script>


